Character pc;
ArrayList npcs;

Boolean showKeyboard = false;
Character cCollided;

PImage keyboardG;
String workingEmoticon = "";
PFont font;

// 0 = moving
// 1 = typing
int MODE = 0;

void setup() {
  size(1000, 600);
  pc = new Character("pc");

  npcs = new ArrayList();
  int randChars = (int) random(7) + 1;
  for (int i = 0; i < randChars; i++) {
    int randomX = (int) random(width-200) + 100;
    int randomY = (int) random(height-200) + 100;
    Character npc = new Character("npc" + i, randomX, randomY);
    npcs.add(npc);
  }
  keyboardG = loadImage("keyboard.png");
  keyboardG.resize(pc.state.emoSize * 15, 0);
  font = loadFont("Gisha-12.vlw");
}

void update() {
  if (keyPressed && MODE == 0) {
    if (key == CODED) {
      if (keyCode == UP) moveCharacter(pc, 0);
      if (keyCode == RIGHT) moveCharacter(pc, 1);
      if (keyCode == DOWN) moveCharacter(pc, 2);
      if (keyCode == LEFT) moveCharacter(pc, 3);
    } 
    else {
      if (key == 'w') moveCharacter(pc, 0);
      if (key == 'd') moveCharacter(pc, 1);
      if (key == 's') moveCharacter(pc, 2);
      if (key == 'a') moveCharacter(pc, 3);
    }
  }
  pc.updateCharacter();

  // Check for which character to interact with
  Boolean collisionD = false;
  cCollided = null;
  for (int i = 0; i < npcs.size(); i++) {
    Character c = (Character) npcs.get(i);
    c.updateCharacter();

    // if the player comes within 20 pixels
    if (pc.checkColl(c.collX - 10, c.collY-10, c.wid + 20, c.wid + 20)) {
      collisionD = true;
      cCollided = c;
      //println("collided with " + c.name);
      targetC = c;
    }
  }

  // Show the keyboard graphic if in range to type
  if (collisionD == true){
    showKeyboard = true;
  } else {
    showKeyboard = false;
    targetC = null;
  }
}

void draw() {
  update();
  background(30);
  pc.drawCharacter();
  noFill();
  stroke(0, 255, 0);
  rect(pc.collX, pc.collY, pc.wid, pc.wid);

  for (int i = 0; i < npcs.size(); i++) {
    Character c = (Character) npcs.get(i);
    c.drawCharacter();
    noFill();
    stroke(255, 0, 0);
    //rect(c.collX - 10, c.collY-10, c.wid + 20, c.wid + 20);
  }

  if (showKeyboard) {
    image(keyboardG, pc.collX, pc.collY + pc.wid + 30);
  }
  // Show textbox & text
  if (MODE == 1){
    fill (255);
    stroke(0);
    rect(pc.collX, pc.collY + pc.wid + 5, pc.wid, 20);
    fill(0);
    textFont(font);
    text(workingEmoticon, pc.collX + 4, pc.collY + pc.wid + 19);
  }
}


void moveCharacter(Character c, int direction) {
  //println("Moving " + c.name + " " + direction);
  switch(direction) {
  case 0:
    c.ypos -= c.speed;
    break;
  case 1:
    c.xpos += c.speed;
    break;
  case 2:
    c.ypos += c.speed;
    break;
  case 3:
    c.xpos -= c.speed;
    break;
  default:
    break;
  }
}

void reset() {
  pc = new Character("pc");

  npcs = new ArrayList();
  int randChars = (int) random(7) + 1;
  for (int i = 0; i < randChars; i++) {
    int randomX = (int) random(width-200) + 100;
    int randomY = (int) random(height-200) + 100;
    Character npc = new Character("npc" + i, randomX, randomY);
    npcs.add(npc);
  }
}

void keyPressed() {
  if (MODE == 0) {
    if (key == 'r') reset();
    if (keyCode == ENTER) {
      MODE = 1;
      workingEmoticon = "";
    }
  } 
  else if (MODE == 1) {
    if (keyCode == ENTER || keyCode == RETURN){
      parseInput();
      MODE = 0;
      workingEmoticon = "";
    }
    if (keyCode == ESC) {
      MODE = 0;
      workingEmoticon = "";
    }
    if (keyCode == BACKSPACE && workingEmoticon != ""){
      println("BACKSPACE");
      workingEmoticon = workingEmoticon.substring(0, workingEmoticon.length()-1);
    } else if (key != CODED && key != SHIFT && keyCode != SHIFT && key != ENTER && keyCode != ENTER && workingEmoticon.length() < 10){
      println("appending key " + key);
      workingEmoticon += key;
    }
  }
}

